=== debian/changelog ===
haxe (1:4.3.7-1) unstable; urgency=medium

  * New upstream version.
  * Remove ocaml5.3.patch and mbedtls3.patch, which were integrated in this
    version already.
  * Bump Standards-Version to 4.7.2 (no changes).

 -- Andy Li <andy@onthewings.net>  Sat, 06 Sep 2025 05:18:22 +0000
