=== debian/watch ===
version=4
opts="uversionmangle=s/-/~/g" \
 https://github.com/HaxeFoundation/haxe/tags .*/archive/refs/tags/(\d\S*)\.tar\.gz
